package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.GP_PricingCategoriaDAO;
import com.rjconsultores.ventaboletos.entidad.Categoria;
import com.rjconsultores.ventaboletos.entidad.GP_Pricing;
import com.rjconsultores.ventaboletos.entidad.GP_PricingCategoria;
import com.rjconsultores.ventaboletos.service.GP_PricingCategoriaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("gp_pricingCategoriaService")
public class GP_PricingCategoriaServiceImpl implements GP_PricingCategoriaService {

    @Autowired
    private GP_PricingCategoriaDAO pricingCategoriaDAO;

    public List<GP_PricingCategoria> obtenerTodos() {
        return pricingCategoriaDAO.obtenerTodos();
    }

    public GP_PricingCategoria obtenerID(Integer id) {
        return pricingCategoriaDAO.obtenerID(id);
    }

    @Transactional
    public GP_PricingCategoria suscribir(GP_PricingCategoria entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(GP_Pricing.ATIVO);

        return pricingCategoriaDAO.suscribir(entidad);
    }

    @Transactional
    public GP_PricingCategoria actualizacion(GP_PricingCategoria entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(GP_Pricing.ATIVO);

        return pricingCategoriaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(GP_PricingCategoria entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(GP_Pricing.EXCLUIDO);

        pricingCategoriaDAO.actualizacion(entidad);
    }

    public Boolean obtenerPricingCategoria(GP_Pricing pricing, Categoria categoria) {
        return pricingCategoriaDAO.obtenerPricingCategoria(pricing, categoria);
    }
    
    public List<GP_PricingCategoria> obtenerTodoPorPricing(GP_Pricing pricing) {
    	return pricingCategoriaDAO.obtenerTodoPorPricing(pricing);
	}
}
